import { mochaRun } from '../../../util.js';
import { ForumTest } from './forum.test-util.js';

describe('Forum', function tests() {
  this.timeout(0);

  const forumTest = new ForumTest();

  before(async () => {
    await forumTest.setup();
  });

  context('Post with multiple authors', async () => {
    let forum;
    let experts;
    let posts;

    before(async () => {
      forum = forumTest.forum;
      experts = forumTest.experts;
      posts = forumTest.posts;

      await forumTest.newExpert({ announce: true });
      await forumTest.newExpert({ announce: true });
    });

    it('Post1', async () => {
      const authors = [
        { author: experts[0], weight: 0.5 },
        { author: experts[1], weight: 0.25 },
        { author: experts[2], weight: 0.25 },
      ];
      await forumTest.addPost(authors, 10);
      forum.getPost(posts[0]).value.should.equal(10);
    });
  });
});

mochaRun();
